
/*
Przykad programu do obsugi moduu AVT1615 z:
- wywietlaczem LCD 2x16 znakw
- 4 diodami LED
- 4 przyciskami
- brzczykiem piezzo
- czujnikiem temperatury LM35
*/


#include <LiquidCrystal.h>  //biblioteka obsugi LCD

const int Led1 =  13;       //przypisanie aliasw do pinw portw
const int Led2 =  12; 
const int Led3 =  11; 
const int Led4 =  10; 
const int SW1 =  3; 
const int SW2 =  2; 
const int SW3 =  1; 
const int SW4 =  0; 
const int Buzzer =  A5; 

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);  //konfigurowanie linii do ktrych zosta doczony LCD

int wart_pot;          //zmienna na warto zmierzona z potencjometru
int wart_czuj;         //zmienna na warto zmierzonej z czujnika temperatury
float wart_nap;        //zmienna na warto zmierzonego napicia
float temperatura;     //zmienna na warto zmierzonej temperatury

byte st[8] = {         //tablica znaku stopnia dla wywietlacza LCD
  B00100,
  B01010,
  B00100,
  B00000,
  B00000,
  B00000,
  B00000,
};

void setup() {            //funkcja inicjalizacji
  lcd.begin(16, 2);       //konfigurowanie rozdzielczoci LCD
  lcd.createChar(0, st);  //funkcja utworzenia wasnego znaku z tablicy st o kodzie 0
  analogReference(DEFAULT); //konfigurowanie napicia odniesienia
                            //dla przetwornika A/C - domylnie 5V
  pinMode(Led1, OUTPUT);    //konfigurowanie I/O, do ktrych s
                            //doczone diody LED
  pinMode(Led2, OUTPUT);
  pinMode(Led3, OUTPUT);
  pinMode(Led4, OUTPUT);
  pinMode(Buzzer, OUTPUT);  //konfigurowanie I/O, do ktrej jest
                            //doczony brzczyk piezzo
  pinMode(SW1, INPUT);      //konfigurowanie I/O, do ktrych s
                            //doczone przyciski
  pinMode(SW2, INPUT);
  pinMode(SW3, INPUT);
  pinMode(SW4, INPUT);
  digitalWrite(SW1, HIGH);  //doczenie wewntrznych rezystorw
                            //zasilajcych
  digitalWrite(SW2, HIGH);
  digitalWrite(SW3, HIGH);
  digitalWrite(SW4, HIGH);
  digitalWrite(Led1, HIGH);    //wyczenie diod LED
  digitalWrite(Led2, HIGH);
  digitalWrite(Led3, HIGH);
  digitalWrite(Led4, HIGH);
  digitalWrite(Buzzer, HIGH);  //wyczenie brzczyka piezzo
}

void loop() {               //ptla gwna programu
  lcd.clear();              //czyszczenie LCD
  lcd.setCursor(4, 0);      //ustawienie kursora w 5 kolumnie
                            //pierwszego wiersza
  lcd.print("Arduino");     //wywietlenie na LCD napisu Arduino
//pomiar napicia z potencjometru i dodanie wyniku do wart_pot
  for (int i = 0; i < 20; i++) {	  //ptla wykonywana 20 razy
    wart_pot = wart_pot + analogRead(A0);
  }
//obliczenie redniej arytmetycznej z 20 pomiarw
  wart_pot = wart_pot / 20;
//przeliczenie odczytanej wartoci na napicie
  wart_nap=(5.0*wart_pot)/1024.0;
//ustawienie kursora w pierwszej pozycji drugiego wiersza LCD
  lcd.setCursor(0, 1);
  lcd.print("U=");          //wywietlenie napisu U=
  lcd.print(wart_nap);      //wywietlenie napicia
  lcd.print("V");           //wywietlenie znaku V

  for (int i = 0; i < 20; i++) {	  //ptla wykonywana 20
//pomiar napicia z czujnika temperatury i dodawanie wart_czuj
    wart_czuj = wart_czuj + analogRead(A1);
  }
//obliczenie redniej arytmetycznej z 20 pomiarw
  wart_czuj = wart_czuj / 20;
//przeliczenie wartoci na stopnie Celsjusza
temperatura=(5.0*wart_czuj*100)/1024.0;
//ustawienie kursora na pozycji 9 drugiego wiersza LCD  lcd.setCursor(9, 1);
  lcd.print("T=");              //wywietlenie napisu T=
  lcd.print((long)temperatura);
//wywietlenie wartoci temperatury zaokrglonej do penych stopni
  lcd.write(0);                 //wywietlenie znaku stopnia
  lcd.print("C");               //wywietlenie znaku C
  
//sprawdzenie czy nacinito przycisk S1
  if (digitalRead(SW1) == LOW) {
    digitalWrite(Led1, LOW);    //zawiecenie LED1
    digitalWrite(Buzzer, LOW);  //wczenie brzczyka
    lcd.clear();                //czyszczenie LCD
//ustawienie kursora w pierwszym rzdzie i drugiej kolumnie    lcd.setCursor(2, 0);
    lcd.print("Przycisk S1");   //wywietlenie nazwy przycisku
//oczekiwanie na zwolnienie przycisku S1
    while(digitalRead(SW1) == LOW);
 } else {                       //w przeciwnym razie
    digitalWrite(Led1, HIGH);   //wyczenie diody LED1
    digitalWrite(Buzzer, HIGH); //wyczenie brzczyka
  }

 if (digitalRead(SW2) == LOW) { //sprawdzenie czy nacinito S2
    digitalWrite(Led2, LOW);
    digitalWrite(Buzzer, LOW);
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("Przycisk S2");
    while(digitalRead(SW2) == LOW);
  } else {
    digitalWrite(Led2, HIGH);
    digitalWrite(Buzzer, HIGH);
  }

 if (digitalRead(SW3) == LOW) { //sprawdzenie czy nacinito S3
    digitalWrite(Led3, LOW);
    digitalWrite(Buzzer, LOW);
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("Przycisk S3");
    while(digitalRead(SW3) == LOW);
  } else {
    digitalWrite(Led3, HIGH);
    digitalWrite(Buzzer, HIGH);
  }

 if (digitalRead(SW4) == LOW) { //sprawdzenie czy nacinito S4
    digitalWrite(Led4, LOW);
    digitalWrite(Buzzer, LOW);
    lcd.clear();
    lcd.setCursor(2, 0);
    lcd.print("Przycisk S4");
    while(digitalRead(SW4) == LOW);
  } else {
    digitalWrite(Led4, HIGH);
    digitalWrite(Buzzer, HIGH);
  }

  delay(300);                   //opnienie o 300ms
}                               //koniec ptli gwnej
