/*
Przykład obsługi komponentów jakie zawiera moduł sterowania serw joystickiem.
 Program zawiera przykład konfiguracji i obsługi:
 - joysticka sterujacego dwoma serwami
 - przycisk SW1 zapala LED1 oraz ustawia serwe 3 w pozycji 0 stopni
 - przycisk SW2 zapala LED2 oraz ustawia serwe 3 w pozycji 180 stopni
 Przycisk joysticka zamienia dzialanie serwa 1 i 2
 */
#include <Servo.h> //biblioteka obslugi serw

Servo servo1;  // objekt serwo 1 
Servo servo2;  // oblekt serwo 2 
Servo servo3;  // objekt serwo 4 

const int Led1 =  6;         //przypisanie aliasów do pinów portów
const int Led2 =  5; 
const int SW1 =  3; 
const int SW2 =  4; 
const int SWJ =  2; 
int temp1;    // zmienne pomocnicze 
int temp2;     
byte flaga = 0; //zmienna flaga

void setup() //petla konfiguracyjna programu
{ 
  servo1.attach(8);  // konfiguracja pinu serwa 1 
  servo2.attach(9);  // konfiguracja pinu dla serwa 2 
  servo3.attach(10);  // konfiguracja pinu dla serwa 3 
  pinMode(SW1, INPUT);        //konfiguracja linii do ktorych sa dolaczone przyciski jako wejscia
  pinMode(SW2, INPUT);
  pinMode(SWJ, INPUT);
  digitalWrite(SW1, HIGH);   //dolaczenie do linii do ktorych sa dolaczone przyciski rezystorow podciagajacych co wymusi na nich domyslnie stan wysoki
  digitalWrite(SW2, HIGH);
  digitalWrite(SWJ, HIGH);
  pinMode(Led1, OUTPUT);    //Konfiguracja linii do ktorych sa dolaczone diody jako wyjscia
  pinMode(Led2, OUTPUT);
  digitalWrite(Led1, LOW);  //domyslne ustawienie stanu diod LED
  digitalWrite(Led2, HIGH);
  servo3.write(0);  //ustawienie serwa 3 w pozycji 0 stopni
} 

void loop()   //petla glowna programu
{ 
  temp1 = analogRead(A0);            // odczyt wartosci analogowej z joysticka lewo - prawo 
  temp2 = analogRead(A1);            // odczyt wartosci analogowej z joysticka gora - dol 
  temp1 = map(temp1, 0, 1023, 0, 179);     // skalowanie odczytanej wartosci analogowej na wartosci od 0 do 180 stopni dla serwa 
  temp2 = map(temp2, 0, 1023, 0, 179);     // skalowanie odczytanej wartosci analogowej na wartosci od 0 do 180 stopni dla serwa 
  if (flaga==0)  //jesli zmienna flaga rowna 0 to
  {
    servo1.write(temp1);                  // ustawienie serwa 1 wartoscia w temp1
    servo2.write(temp2);                  // ustawienie serwa 2 wartoscia w temp2 
  }
  else      //w przeciwnym razie
  {
    servo1.write(temp2);                  // ustawienie serwa 1 wartoscia w temp2
    servo2.write(temp1);                  // ustawienie serwa 2 wartoscia w temp1 
  }

  delay(15);                           // opoznienie 15 ms

 if (digitalRead(SWJ) == LOW) {         //Sprawdzenie czy nacisniety przycisk SWJ
    flaga=!flaga;      //odwrocenie stanu flagi flaga
    while(digitalRead(SWJ) == LOW);    //oczekiwanie na puszczenie przycisku S1
  } 

  if (digitalRead(SW1) == LOW) {         //Sprawdzenie czy nacisniety przycisk S1
    digitalWrite(Led1, LOW);              // Zapalenie LED1
    digitalWrite(Led2, HIGH);              // zgaszenie LED2
    servo3.write(0);                  // ustawienie pozycji serwa 3 
    while(digitalRead(SW1) == LOW);    //oczekiwanie na puszczenie przycisku S1
  } 
  if (digitalRead(SW2) == LOW) {         //Sprawdzenie czy nacisniety przycisk S2
    digitalWrite(Led1, HIGH);              // Zgaszenie LED1
    digitalWrite(Led2, LOW);              // Zapalenie LED2
    servo3.write(180);                  // ustawienie pozycji serwa 3 
    while(digitalRead(SW2) == LOW);    //oczekiwanie na puszczenie przycisku S1
  } 
} 


