/*
Przykład obsługi magistrali 1
Odczyt temperatury z czujnika DS18B20 oraz przesłanie wyniku poziomu do terminala.
 */

#include <OneWire.h> //biblioteka 1Wire

OneWire  ds(A3);        // konfiguracja linii 1Wire
byte data[12];    //tablica na dane
int HighByte, LowByte, SignBit, temp, Fract, TReading, Tc_100;    //zmienne wykorzystywane do obliczenia temperatury

void setup()        //procedura konfiguracyjna
{ 
  Serial.begin(9600);   //konfiguracja predkosci transmisji
} 

void loop()     //petla glowna programu
{
  Serial.print("Temperatura: ");   //wyslanie komunikatu tekstowego   
  Serial.println(getTemp());    //wyslanie zmierzonej temperatury
  delay(500);            //opoznienie 500 ms
} 

int getTemp() {    //procedura odczytu temperatury z czujnika 1Wire DS18B20
  int foo, bar, i;   //definicje zmiennych
  ds.reset();  //zerowanie ukladu 1Wire
  ds.write(0xCC,1);   //komendy startujace pomiar temperatury
  ds.write(0x44,1);

  ds.reset();   //instrukcje odczytu temperatury
  ds.write(0xCC,1);
  ds.write(0xBE);

  for ( i = 0; i < 9; i++) {  //odczyt danych z czujnika
    data[i] = ds.read();
  }
  LowByte = data[0];  //instrukcje obliczajace temperature ktorej wynik jest zapisywany
  HighByte = data[1];  //do zmiennej temp
  TReading = (HighByte << 8) + LowByte;
  SignBit = TReading & 0x8000;  //obliczenie znaku temperatury
  if (SignBit) {    //instrukcje wykonywane w zaleznosci od znaku temeratury
    TReading = -TReading;
  }
  Tc_100 = (6 * TReading) + TReading / 4;    
  temp = Tc_100 / 100;          
  Fract = Tc_100 % 100;
  if (Fract > 49) {
    if (SignBit) {
      --temp;
    } 
    else {
      ++temp;
    }
  }
  return temp;    //zwrocenie wartosci obliczonej temeratury
} 






