/*
Przykład obsługi zegara RTC PCF8583 z wykorzystaniem magistrali I2C.
Wysyłanie daty oraz czasu do terminala.
Przycisk S2 zwiększa wartość godzin, przycisk S1 zwiększa wartość minut.
 */

#include <Wire.h> //biblioteka i2c
#include <PCF8583.h>  //biblioteka RTC

PCF8583 p (0xA0);       //konfiguracja adresu ukladu RTC8583
const int SW1 =  A1;   //konfiguracja aliasow linii portow do ktorych dolaczono przyciski
const int SW2 =  A2;

void setup()        //procedura konfiguracyjna
{ 
  Serial.begin(9600);   //konfiguracja predkosci transmisji
  p.hour = 14;  //wartosci poczatkowe dla ukladu RTC - godzina
  p.minute = 30;  //minuty
  p.second = 0;  //sekundy
  p.year = 2011;  //rok
  p.month = 4;  //miesiac
  p.day = 16;  //dzien
  p.set_time();   //wyslanie ustawien daty i czasu do RTC
  pinMode(SW1, INPUT);        //konfiguracja linii do ktorych sa dolaczono przyciski jako wejscia
  pinMode(SW2, INPUT);
  digitalWrite(SW1, HIGH);   //dolaczenie do linii do ktorych sa dolaczone przyciski rezystorow podciagajacych co wymusi na nich domyslnie stan wysoki
  digitalWrite(SW2, HIGH);
} 

void loop()     //petla glowna programu
{
  p.get_time();  //pobranie z RTC danych o czasie i dacie
  Serial.print("Data: ");  //przykladowy tekst
  Serial.print(p.day);  //wyslanie dnia
  Serial.print("-");//przykladowy tekst
  Serial.print(p.month);  //wyslanie miesiaca
  Serial.print("-");//przykladowy tekst
  Serial.print(p.year);  //wyslanie roku
  Serial.print("  Czas: ");//przykladowy tekst
  Serial.print(p.hour);  //wyslanie godziny
  Serial.print(".");//przykladowy tekst
  Serial.print(p.minute);  //wyslanie minuty
  Serial.print(".");//przykladowy tekst
  Serial.println(p.second);  //wyslanie sekund
  if (digitalRead(SW1) == LOW) {         //Sprawdzenie czy nacisniety przycisk S1
    p.minute++;  //zwiekszenie o jeden wartosci minut
    p.set_time();  //wyslanie ustawien do RTC
    while(digitalRead(SW1) == LOW);   //jesli przycisk nadal przycisniety to czekaj na jego puszczenie
   }
  if (digitalRead(SW2) == LOW) {         //Sprawdzenie czy nacisniety przycisk S2
    p.hour++;    //zwiekszenie o jeden wartosci godzin
    p.set_time();  //wyslanie ustawiec do RTC
    while(digitalRead(SW2) == LOW);  //jesli przycisk S2 nadal nacisniety to czekaj na jego puszczenie
   }
  delay(500);   //opoznienie 500 ms
}  




