/*
Przykład obsługi linii I/O mikrokontrolera.
Dolinii wejsciowych dolaczony 4 przyciski
Do linii wyjsciowych dolaczono 4 diody LED oraz generator PIEZO
Przycisniecie przycisku S1 powoduje zapalenie diody LED1
Przycisniecie przycisku S2 powoduje miganie diody LED2
Przycisniecie przycisku S3 powoduje generacje kodu SOS w kodzie Morse'a (SOS sygnalizowane jest miganiem LED3 oraz sygnalem z przeczyka PIEZO)
Przycisniecie przycisku S4 powoduje generowanie efekty swietlnego weza z wykorzystaniem diod LED1 - LED4
 */

const int Led1 =  13;         //przypisanie aliasów do pinów portów
const int Led2 =  12; 
const int Led3 =  11; 
const int Led4 =  10; 
const int SW1 =  3; 
const int SW2 =  2; 
const int SW3 =  1; 
const int SW4 =  0; 
const int Buzzer =  A5; 

void setup() {            //funkcja inicjalizacji
  pinMode(Led1, OUTPUT);    //Konfiguracja linii do ktorych sa dolaczone diody jako wyjscia
  pinMode(Led2, OUTPUT);
  pinMode(Led3, OUTPUT);
  pinMode(Led4, OUTPUT);
  pinMode(Buzzer, OUTPUT);    //konfiguracja linii do ktorej jest dolaczony brzeczyk jako wyjscie
  pinMode(SW1, INPUT);        //konfiguracja linii do ktorych sa dolaczone przyciski jako wejscia
  pinMode(SW2, INPUT);
  pinMode(SW3, INPUT);
  pinMode(SW4, INPUT);
  digitalWrite(SW1, HIGH);   //dolaczenie do linii do ktorych sa dolaczone przyciski rezystorow podciagajacych co wymusi na nich domyslnie stan wysoki
  digitalWrite(SW2, HIGH);
  digitalWrite(SW3, HIGH);
  digitalWrite(SW4, HIGH);
  digitalWrite(Led1, HIGH);  //domyslne wylaczenie diod LED
  digitalWrite(Led2, HIGH);
  digitalWrite(Led3, HIGH);
  digitalWrite(Led4, HIGH);
  digitalWrite(Buzzer, HIGH);  //domyslne wylaczenie brzeczyka
}

void loop() {                //petla glowna programu
  if (digitalRead(SW1) == LOW) {         //Sprawdzenie czy nacisniety przycisk S1
    digitalWrite(Led1, LOW);              // Zapalenie LED1
    while(digitalRead(SW1) == LOW);    //oczekiwanie na puszczenie przycisku S1    
  } 
  else {                              //w przeciwnym razie
    digitalWrite(Led1, HIGH);          //wylaczenie diody LED1
  }

  if (digitalRead(SW2) == LOW) {         //Sprawdzenie czy nacisniety przycisk S2
    while(digitalRead(SW2) == LOW)      //jesli przycisk nadal przycisniety
    {
      digitalWrite(Led2, LOW);        //wlaczenie LED2
      delay(200);      //opoznienie 200 ms
      digitalWrite(Led2, HIGH);   //wylaczenie LED2
      delay(200);    //opoznienie 200 ms

    }   
  } 
  else {                              //w przeciwnym razie
    digitalWrite(Led2, HIGH);          //wylaczenie diody LED2
  }

  if (digitalRead(SW3) == LOW) {         //Sprawdzenie czy nacisniety przycisk S3
    while(digitalRead(SW3) == LOW)    //jesli przycisk nadal przycisniety
    {
      for (int i=0; i<3; i++) {      //petla genetujaca trzy kropki
        digitalWrite(Led3, LOW); // wlaczenie Led3
        digitalWrite(Buzzer, LOW);   //wlaczenie brzeczyka
        delay(150); // opoznienie 150 ms
        digitalWrite(Led3, HIGH); // wylaczenie led3
        digitalWrite(Buzzer, HIGH); //wylaczenie brzeczyka
        delay(100); // opoznienie 100 ms
      }
       for (int i=0; i<3; i++) {    //petla genetujaca trzy kreski
        digitalWrite(Led3, LOW); // // wlaczenie Led3
        digitalWrite(Buzzer, LOW);//wlaczenie brzeczyka
        delay(400); // opoznienie 400 ms
        digitalWrite(Led3, HIGH); // wylaczenie led3
        digitalWrite(Buzzer, HIGH);  //wylaczenie brzeczyka
        delay(100); // opoznienie 100 ms
      }      
      for (int i=0; i<3; i++) {    //petla genetujaca trzy kropki
        digitalWrite(Led3, LOW);    // wlaczenie Led3
        digitalWrite(Buzzer, LOW);//wlaczenie brzeczyka
        delay(150); // opoznienie 150 ms
        digitalWrite(Led3, HIGH); // wylaczenie led3
        digitalWrite(Buzzer, HIGH);  //wylaczenie brzeczyka
        delay(100); // opoznienie 100 ms
      }
      delay(2000);     //opoznienie 2 sekundy
    }    
  } 
  else {                              //w przeciwnym razie
    digitalWrite(Led3, HIGH);          //wylaczenie diody LED3
    digitalWrite(Buzzer, HIGH);        //wylaczenie brzeczyka
  }

  if (digitalRead(SW4) == LOW) {         //Sprawdzenie czy nacisniety przycisk S4
    while(digitalRead(SW4) == LOW)//jesli przycisk nadal przycisniety
    {
      digitalWrite(Led1, LOW);  //wlaczenie Led1
      delay(100); //opoznienie 100 ms
      digitalWrite(Led2, LOW);//wlaczenie Led2
      delay(100); //opoznienie 100 ms
      digitalWrite(Led3, LOW);//wlaczenie Led3
      delay(100); //opoznienie 100 ms
      digitalWrite(Led4, LOW);//wlaczenie Led4
      delay(100); //opoznienie 100 ms
      digitalWrite(Led1, HIGH);  //wylaczenie Led1
      delay(100); //opoznienie 100 ms
      digitalWrite(Led2, HIGH);//wylaczenie Led2
      delay(100); //opoznienie 100 ms
      digitalWrite(Led3, HIGH);//wylaczenie Led3
      delay(100); //opoznienie 100 ms
      digitalWrite(Led4, HIGH);//wylaczenie Led4
      delay(100);  //opoznienie 100 ms
    }  
  } 
  delay(300);                          //opoznienie 300 ms
}                                      //koniec petli glownie programu


