/*
Przykład obsługi wyświetlacza LCD
Wyświetlenie na LCD przykładowego tekstu oraz wartości analogowej i napieciowej zmierzonej z wyjscia potencjometru. 
*/

#include <LiquidCrystal.h>    //biblioteka obsługi LCD

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);    //konfuguracja linii do ktorych został dołaczony LCD

int wart_pot;              //zmienna na wartosc zmierzona z potencjometru
float wart_nap;            //zmienna na wartosc zmierzonego napiecia

void setup() {            //funkcja inicjalizacji
  lcd.begin(16, 2);        //konfiguracja rozdzielczosci wyswietlacza LCD
  analogReference(DEFAULT);   //konfiguracja napiecia odniesienia dla przetwornika A/C - domyslnie napieciem odniesienia jest 5V.
}

void loop() {                //petla glowna programu
  lcd.clear();              //czyszczenie LCD
  lcd.setCursor(3, 0);      //ustawienie kursora w 4 kolumnie pierwszego wiersza
  lcd.print("Analog I/O");      //wyswietlenie na LCD napisu Analog I/O
  wart_pot = analogRead(A0); //pomiar napiecia z potencjometru do zmiennej wart_pot
  wart_nap=(5.0*wart_pot)/1024.0;        //przeliczenie odczytanej wartosci na napiecie
  lcd.setCursor(0, 1);                  //ustawienie kursora w pierwszej pozycji drugiego wiersza LCD
  lcd.print("U=");                      //wyswietlenie napisu U=
  lcd.print(wart_nap);                  //wyswietlenie zmierzonej wartosci napiecia z potencjometru
  lcd.print("V");                      //wyswietlenie znaku V
  lcd.setCursor(8, 1);                  //ustawienie kursora w 8 pozycji drugiego wiersza LCD
  lcd.print("A/C=");                      //wyswietlenie napisu A/C=
  lcd.print(wart_pot);                  //wyswietlenie zmierzonej wartosci przez A/C
  delay(300);                          //opoznienei 300ms
}                                      //koniec petli glownie programu


