/*
Przykład obsługi pamieci EEPROM mikrokontrolera o pojemnosci 512 bajtow
W pierwszej kolejnosci czyszczona jest zawartosc EEPROM
Nastepnie pamiec wypelniana jest liczbami z zakresu od 0 do 255.
Nastepnie odczytywane sa wartosci z pamieci EEPROM i wyswietlane na wyswietlaczu LCD
 */

#include <EEPROM.h>   //biblioteka obslugi pamieci EEPROM
#include <LiquidCrystal.h>    //biblioteka obsługi LCD

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);    //konfuguracja linii do ktorych został dołaczony LCD

byte wart;              //zmienna na wartosc odczytana z EEPROM

void setup() {            //funkcja inicjalizacji
  lcd.begin(16, 2);        //konfiguracja rozdzielczosci wyswietlacza LCD
}

void loop() {                //petla glowna programu
  for (int i = 0; i < 512; i++)  //petla czyszczaca zawartosc EEPROM
  {
    EEPROM.write(i, 0);   //zapis do komorki wskazywanej przez zmienna i wartosci 0
    lcd.setCursor(0, 0);  //kursor na poczatek ekranu LCD
    lcd.print("Clear EEPROM");  //komunikat wyswietlany w pierwszej linii LCD
    delay(1);   //opoznienie 1 ms;
  } 
  for (int i = 0; i < 512; i++)  //petla zapisujaca dane do EEPROM
  {
    EEPROM.write(i, i);  //zapis do komorki wskazywanej przez i wartosci i
    lcd.setCursor(0, 0);//kursor na poczatek ekranu LCD
    lcd.print("Write EEPROM");//komunikat wyswietlany w pierwszej linii LCD
    lcd.setCursor(0, 1);      //ustawienie kursora w 1 kolumnie drugiego wiersza
    lcd.print(i,DEC);      //wyswietlenie na LCD zapisywanej danej do EEPROM
    delay(50);    //opoznienie 50 ms
  }

  for (int i = 0; i < 512; i++)    //petla odczytujaca dane z EEPROM
  {
    wart = EEPROM.read(i);  //odczyt komorki pamieci do zmiennej wart o adresie wskazywanym przez zmienna i
    lcd.clear();              //czyszczenie LCD
    lcd.setCursor(0, 0);//kursor na poczatek ekranu LCD
    lcd.print("Read EEPROM");//komunikat wyswietlany w pierwszej linii LCD
    lcd.setCursor(0, 1);      //ustawienie kursora w 1 kolumnie drugiego wiersza
    lcd.print(wart,DEC);      //wyswietlenie na LCD odczytanej danej z pamieci EEPROM
    delay(100);                          //opoznienie 100ms
  }
  lcd.clear();              //czyszczenie LCD
  lcd.setCursor(0, 0);    //ustawienie kursora na poczatek LCD
  lcd.print("END");    //wyswietlenie napisu END
  while(1);          //nieskonczona petla
}                                      //koniec petli glownej programu


