/*
Przykład obsługi komponentów jakie zawiera moduł obsługi silników DC dla Arduino UNO.
 Program zawiera przykład konfiguracji i obsługi:
 - sterowanie 4 - silnikami
 - regulacja predkosci silnikow
 - zmiana kierunku obrotu
Przycisk S1 i S3 umożliwiaja właczenie silników, przyciski S2, S4 zmiane kierunku obrotow natomiast potencjometry umozliwiaja regulacje predkosci.
Modul steruje 4 silnikami w dwoch grupach w ktorych kazdy obraca sie w przeciwnym kierunku.
Dioda Led1 wskazujew wlaczenie silnika M1, M2 a Led2 silnika M3 i M4
 */

const int Motor_1_A =  12;   //przypisanie aliasow linia portow
const int Motor_1_B =  10;   //przypisanie aliasow linia portow
const int Motor_2_A =  11;   //przypisanie aliasow linia portow
const int Motor_2_B =  9;   //przypisanie aliasow linia portow
const int Motor_3_A =  3;   //przypisanie aliasow linia portow
const int Motor_3_B =  5;   //przypisanie aliasow linia portow
const int Motor_4_A =  6;   //przypisanie aliasow linia portow
const int Motor_4_B =  4;   //przypisanie aliasow linia portow
const int Motor_1_S =  13;   //przypisanie aliasow linia portow
const int Motor_2_S =  8;   //przypisanie aliasow linia portow
const int Motor_3_S =  2;   //przypisanie aliasow linia portow
const int Motor_4_S =  7;   //przypisanie aliasow linia portow
const int LED1 =  A2;   //przypisanie aliasow linia portow
const int LED2 =  A3;   //przypisanie aliasow linia portow
const int SW1 =  1;   //przypisanie aliasow linia portow
const int SW2 =  0;   //przypisanie aliasow linia portow
const int SW3 =  A4;   //przypisanie aliasow linia portow
const int SW4 =  A5;   //przypisanie aliasow linia portow
const int Pot1 =  A0;   //przypisanie aliasow linia portow
const int Pot2 =  A1;   //przypisanie aliasow linia portow

byte flaga1_on = 0; //zmienna flaga
byte flaga1_obr = 0; //zmienna flaga
byte flaga2_on = 0; //zmienna flaga
byte flaga2_obr = 0; //zmienna flaga
int mot1; //zmienna wartosci z potencjometru Pot1
int mot2;//zmienna wartosci z potencjometru Pot2

void setup()        //procedura konfiguracyjna
{ 
  pinMode(Motor_1_A, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_1_A, LOW);
  pinMode(Motor_1_B, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_1_B, LOW);
  pinMode(Motor_2_A, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_2_A, LOW);
  pinMode(Motor_2_B, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_2_B, LOW);
  pinMode(Motor_3_A, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_3_A, LOW);
  pinMode(Motor_3_B, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_3_B, LOW);
  pinMode(Motor_4_A, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_4_A, LOW);
  pinMode(Motor_4_B, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_4_B, LOW);
  pinMode(Motor_1_S, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_1_S, LOW);
  pinMode(Motor_2_B, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_2_S, LOW);
  pinMode(Motor_3_S, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_3_S, LOW);
  pinMode(Motor_4_B, OUTPUT);     //konfiguracja linii
  digitalWrite(Motor_4_S, LOW);
  pinMode(LED1, OUTPUT);     //konfiguracja Led1
  digitalWrite(LED1, HIGH);
  pinMode(LED2, OUTPUT);     //konfiguracja Led2
  digitalWrite(LED2, HIGH);
  pinMode(SW1, INPUT);        //konfiguracja linii do ktorych sa dolaczono przyciski jako wejscia
  pinMode(SW2, INPUT);
  pinMode(SW3, INPUT);        //konfiguracja linii do ktorych sa dolaczono przyciski jako wejscia
  pinMode(SW4, INPUT);
  digitalWrite(SW1, HIGH);   //dolaczenie do linii do ktorych sa dolaczone przyciski rezystorow podciagajacych co wymusi na nich domyslnie stan wysoki
  digitalWrite(SW2, HIGH);
  digitalWrite(SW3, HIGH);   //dolaczenie do linii do ktorych sa dolaczone przyciski rezystorow podciagajacych co wymusi na nich domyslnie stan wysoki
  digitalWrite(SW4, HIGH);

  analogReference(DEFAULT);   //konfiguracja przetwornika A/C
} 

void loop()     //petla glowna programu
{
  mot1 = analogRead(A0);            // odczyt wartosci analogowej z Pot1 
  delay(10);    //opoznienie 10 ms
  mot2 = analogRead(A1);            // odczyt wartosci analogowej z Pot2 
  delay(10); //opoznienie 10 ms
  
  if (digitalRead(SW1) == LOW) {         //Sprawdzenie czy nacisniety przycisk SW1
    flaga1_on=!flaga1_on;      //odwrocenie stanu flagi flaga1_on wskazujacej zalaczenie silnika M1 i M2
    while(digitalRead(SW1) == LOW);    //oczekiwanie na puszczenie przycisku SW1
  } 
  if (digitalRead(SW2) == LOW) {         //Sprawdzenie czy nacisniety przycisk SW2
    flaga1_obr=!flaga1_obr;      //odwrocenie stanu flagi1_obr wskazujacej kierunek obrotow
    while(digitalRead(SW2) == LOW);    //oczekiwanie na puszczenie przycisku SW2
  } 
  if (flaga1_on == 1) {         //Sprawdzenie czy ustawiona jest flaga1_on, jesli tak to
    digitalWrite(Motor_1_S, HIGH);  //zalaczenie silnika M1
    digitalWrite(Motor_2_S, HIGH);  //zalaczenie silnika M2
    digitalWrite(LED1, LOW);  //zalaczenie diody Led 1
  }
  else   //w przeciwnym razie
  {
    digitalWrite(Motor_1_S, LOW);  //wylaczenie silnika M1
    digitalWrite(Motor_2_S, LOW);  //wylaczenie silnika M2
    digitalWrite(LED1, HIGH);  //wylaczenie Led1
  }
  if (flaga1_obr == 1) {         //Sprawdzenie czy ustawiona flaga1_obr, jesli tak to
    analogWrite(Motor_1_A, (255-(mot1/4)));  //zapisanie wartosci PWM odczytanej z pot1 do M1
    digitalWrite(Motor_1_B, HIGH);  //ustawienie drugiej linii M1
    analogWrite(Motor_2_A, (255-(mot1/4)));  //zapisanie wartosci PWM z Pot1 do M2
    digitalWrite(Motor_2_B, HIGH);  //ustawienie drugiej linii M2
  }
  else   //w przeciwnym razie
  {
    analogWrite(Motor_1_A, mot1/4);  //zapisanie wartosci PWM odczytanej z pot1 do M1
    digitalWrite(Motor_1_B, LOW);    //zerowanie drugiej linii M1
    analogWrite(Motor_2_A, mot1/4);  //zapisanie wartosci PWM odczytanej z pot1 do M2
    digitalWrite(Motor_2_B, LOW);   //zerowanie drugiej linii M2
  }

  if (digitalRead(SW3) == LOW) {         //Sprawdzenie czy nacisniety przycisk SW3
    flaga2_on=!flaga2_on;      //odwrocenie stanu flagi flaga2_on wskazujacej zalaczenie silnika M3 i M4
    while(digitalRead(SW3) == LOW);    //oczekiwanie na puszczenie przycisku SW3
  } 
  if (digitalRead(SW4) == LOW) {         //Sprawdzenie czy nacisniety przycisk SW4
    flaga2_obr=!flaga2_obr;       //odwrocenie stanu flagi2_obr wskazujacej kierunek obrotow
    while(digitalRead(SW4) == LOW);    //oczekiwanie na puszczenie przycisku SW4
  } 
  if (flaga2_on == 1) {         //Sprawdzenie czy ustawiona jest flaga2_on, jesli tak to
    digitalWrite(Motor_3_S, HIGH); //zalaczenie silnika M3
    digitalWrite(Motor_4_S, HIGH);  //zalaczenie silnika M4
    digitalWrite(LED2, LOW);  //zalaczenie diody Led 2
  }
  else  //w przeciwnym razie
  {
    digitalWrite(Motor_3_S, LOW);  //wylaczenie silnika M1
    digitalWrite(Motor_4_S, LOW);  //wylaczenie silnika M1
    digitalWrite(LED2, HIGH);  //wylaczenie Led1
  }
  if (flaga2_obr == 1) {         //Sprawdzenie czy ustawiona flaga2_obr, jesli tak to
    analogWrite(Motor_3_A, (255-(mot2/4)));  //zapisanie wartosci PWM odczytanej z pot2 do M3
    digitalWrite(Motor_3_B, HIGH);  //ustawienie drugiej linii M3
    analogWrite(Motor_4_A, (255-(mot2/4)));  //zapisanie wartosci PWM odczytanej z pot2 do M4
    digitalWrite(Motor_4_B, HIGH);  //ustawienie drugiej linii M4
  }
  else  //w przeciwnym razie
  {
    analogWrite(Motor_3_A, mot2/4);  //zapisanie wartosci PWM odczytanej z pot1 do M3
    digitalWrite(Motor_3_B, LOW);  //zerowanie drugiej linii M3
    analogWrite(Motor_4_A, mot2/4);  //zapisanie wartosci PWM odczytanej z pot1 do M4
    digitalWrite(Motor_4_B, LOW);  //zerowanie drugiej linii M4
  }
} 





